#ifndef _SYMTAB_H_
#define _SYMTAB_H_

#define SYMTAB_SIZE     128


#define SF_FORWARD	(1 << 0)	/* Was this forward reference */
					/* in a call or goto?         */
#define SF_ABS		(1 << 1)	/* Absolute symbol; i.e. EQU */
#define SF_MOD		(1 << 2)	/* Modifiable; i.e. SET */

struct symlist {
  struct symlist *next;
  char *label;
  int val;
  int psect;	/* psect identifier */
  unsigned int flags;
};

/* Hash of 128 symlists. */
extern struct symlist *symtabs[SYMTAB_SIZE];


extern void symInit(void);
extern void symDestroy(void);
extern void symAdd(const char *buf, const int loc, unsigned int f);
extern int symModify(const char *lbl, const int loc, unsigned int f);
extern int symLookup(const char *lbl);
extern int symFlags(const char *lbl);
extern void symDump(FILE *lfp);

extern int symResolveAddr(const char *op);
extern int symResolveLiteral(const char *op);

#define resolve_addr symResolveAddr
// #define resolve_literal symResolveLiteral


#endif
